#include maps\mp\_utility;

Validate_Timeout()
{
	setcvar("pam_timeout", 0);

	if(!isDefined(game["to"]) || game["to"] != 1)
	{
		iprintln("Time-out is not supported by the rules");
		return;
	}
	
	if (level.rdyup || !game["matchstarted"] || level.mapended)
	{
		iprintln("Can only call time-out once the match starts");
		return;
	}
	switch(level.gametype)
	{
		case "sd": TO_Round_Based();break;
		case "ctf":
		case "tdm": TO_Time_Based(); break;
		case "hq":
		default: iprintln("Time-out is not supported in this gametype"); break;
	}
}

TO_Rup()
{
	level notify("timeoutcalled");
	game["timeout"] = true;
	logPrint("TOC\n");
	setcvar("g_speed", 0);
	//display scores
	[[level.pam_hud]]("header");

	if(isDefined(level.clock))
		level.clock destroy();

	to = newHudElem();
	to.x = 570;
	to.y = 175;
	to.alignX = "center";
	to.alignY = "middle";
	to.fontScale = 1.2;
	to.color = (1, 1, 0);
	to setText(game["timeouthead"]);
	thread TO_Clock();
	
	thread Handle_Weapons();
	wait level.fps_multiplier * 1;
	[[level.pam_hud]]("scoreboard");

	level.rdyup = 1;
	level.warmup = 0;
	level.playersready = false;

	level.waiting = newHudElem();
	level.waiting.alignX = "center";
	level.waiting.alignY = "middle";
	level.waiting.color = (.8, 1, 1);
	level.waiting.x = 320;
	level.waiting.y = 370;
	level.waiting.fontScale = 1.2;
	level.waiting.font = "default";
	level.waiting setText(game["waiting"]);

	setClientNameMode("manual_change");
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];

		player.pers["killer"] = 0;

		lpselfnum = player getEntityNumber();
		player.statusicon = "party_notready";
		level.R_U_Name[lpselfnum] = player.name;
		level.R_U_State[lpselfnum] = "notready";
		player.R_U_Looping = 0;

		player thread maps\pam\readyup::readyup(lpselfnum);
	}

	maps\pam\readyup::Waiting_On_Players();

	if(isdefined(level.waiting))
		level.waiting destroy();
	if (isdefined(to))
		to destroy();
	if (isdefined(level.to_clock))
		level.to_clock destroy();
	if (isdefined(level.to_resume))
		level.to_resume destroy();

	setClientNameMode("auto_change");
	game["dolive"] = 1;
	level.rdyup = 0;
	level.warmup = 0;

	[[level.pam_hud]]("kill_all");
	Match_Resume();
}
TO_Clock()
{
	self endon("timeoutover");
	if(game["to_length"] == 0)
		return;
	
	level.to_resume = newHudElem();
	level.to_resume.x = 570;
	level.to_resume.y = 280;
	level.to_resume.alignX = "center";
	level.to_resume.alignY = "middle";
	level.to_resume.font = "default";
	level.to_resume.fontscale = 1.3;
	level.to_resume setText(game["resuming"]);
	
	level.to_clock = newHudElem();
	level.to_clock.x = 570;
	level.to_clock.y = 300;
	level.to_clock.alignX = "center";
	level.to_clock.alignY = "middle";
	level.to_clock.font = "default";
	level.to_clock.fontscale = 1.2;
	level.to_clock setTimer(game["to_length"] * 60);
	
	wait level.fps_multiplier * game["to_length"] * 60;
	
	level.playersready = true;
	if (isdefined(level.to_clock))
		level.to_clock destroy();
	if (isdefined(level.to_resume))
		level.to_resume destroy();
	Match_Resume();
}
TO_Round_Based()
{
	if ((!game["halftimeflag"] && game["roundsplayed"] >= (level.halfround - 1)) || (game["halftimeflag"] && game["roundsplayed"] >= (level.matchround - 1 )) && (isDefined(level.instrattime) && !level.instrattime))
	{
		iprintln("Time-out ignored. Last (half/match) round detected");
		return;
	}
	game["timeout"] = true;
	if (isDefined(level.instrattime) && level.instrattime)
	{
		iprintln("Time-out called. Going to time-out mode now");
		TO_Rup();
		map_restart(true);
	}
	else
	{
		iprintln("Time-out called. Going to time-out mode at the end of the round");
		level waittill("update_teamscore_hud");
		//level waittill("round_ended");
		TO_Rup();
	}
}

TO_Time_Based()
{
	TO_Rup();
}

Match_Resume()
{
	level notify("timeoutover");
	game["timeout"] = false;
	logPrint("TOO\n");
	setcvar("g_speed", 190);
	Handle_Weapons();
	switch (level.gametype)
	{
	case "ctf":
		thread maps\pam\ctf::startGame();
		thread maps\pam\ctf::updateGametypeCvars();
		if (isDefined(level.rogueflag["axis"]) && level.rogueflag["axis"])
		{
			axis_flag = getent("axis_flag", "targetname");
			axis_flag thread maps\pam\ctf::autoReturn();
		}
		if (isDefined(level.rogueflag["allies"]) && level.rogueflag["allies"])
		{
			allied_flag = getent("allied_flag", "targetname");
			allied_flag thread maps\pam\ctf::autoReturn();
		}
		break;
	case "tdm":
		thread maps\pam\tdm::startGame();
		//wait 1;
		thread maps\pam\tdm::updateGametypeCvars();
		break;
	case "sd":
		thread maps\pam\sd::startRound();
		break;
	}
}

Handle_Weapons()
{
	players = getentarray("player", "classname");
	while(game["timeout"])
	{
		players = getentarray("player", "classname");
		for(i=0;i<players.size;i++)
		{
			player = players[i];
			player disableWeapon();
		}
		wait 1;
	}
	for(i=0;i<players.size;i++)
	{
		player = players[i];
		player enableWeapon();
	}
}


Time()
{
	self endon("timeoutcalled");
	self endon("intermission");

    time = getCvarFloat("scr_"+level.gametype+"_timelimit");
	if (time == 0)
		return;
	if (level.timelimit < time)
		time = level.timelimit;

    start = getTime();

    while (!game["timeout"])
    {
		passed = (getTime() - start) / 1000;
		level.timeleft = ((time * 60) - (passed)) / 60;
		wait level.fps_multiplier * 1;
    }
}